--[[ <HCExtension>
@name               (A-size)
@author        DenZzz
@version       1.1  HC v1.00 RC2 (1.0.0.175)   
@description     ,     
@event         AnswerHeaderReceived/Answer
</HCExtension> ]]


function GetContentLength(s)
  _,_,x = string.find(s, '[cC]ontent%-[lL]ength: *(%d+)')
  if x==nil then return -1 else return tonumber(x) end
end

function GetContentType(s)
  _,_,x = string.find(s, '[cC]ontent%-[tT]ype: *(.-) *\r?\n')
  if x~=nil then x = string.lower(x) end
  return x
end

function GetContentEncoding(s)
  _,_,x = string.find(s, '[cC]ontent%-[eE]ncoding: *(.-) *\r?\n')
  if x~=nil then x = string.lower(x) end
  return x
end



function Answer()

 --   GET-
 if hc.method == 'GET' then

  --      'Content-Length' 
  len = GetContentLength(hc.answer_header)

  --          1000 
  if len > 1000 then

   --                  
   if hc.cache_file_size == len then 
    --          
    hc.action = 'dont_update-'
    hc.monitor_string = hc.monitor_string..'A-size '

   --    :
   else    
    --    'Content-Encoding' 
    enc = GetContentEncoding(hc.answer_header)
    --      'Content-Type'
    type = GetContentType(hc.answer_header)

    --    'Content-Encoding'
    if enc ~= nil then
     --         HC 
     if type ~= nil then
      len2 = len + 14 + string.len(type) + 1 + 18 + string.len(enc) + 3
     else
      len2 = len + 18 + string.len(enc) + 3
     end

    --   'Content-Encoding':
    else
     if type ~= nil then 
      --    HTML
      if string.find(type,'text/html',1,true) ~= nil then
       --         HC 
       len2 = len + 5 + string.len(type) + 21 + 4
      end
     end
    end

    --          
    if len2 ~= nil and hc.cache_file_size == len2 then
     --          
     hc.action = 'dont_update-'
     hc.monitor_string = hc.monitor_string..'A-size2 '
    end

   end  --       
  end  --   '  1000 '
 end  --   '  GET-'

end  --   Answer
